body {
	margin: 0;
	padding: 0;
	background-color: hsl(226, 28%, 98%);
}

.dropdown-item, .popout *:first-child {
	cursor: pointer;
}

.dropdown-item {
	font-size: 1.3em !important;
}

.dropdown-item:hover {
	background-color: #afe7ff !important;
}

.hidden {
	display: none;
}

.loading {
	background-color: gray;
	opacity: 0.7;
	z-index: 1;
}

.loading .absolute {
	position: absolute;
}

.loading-description {
	max-width: 30%;
	background-color: black;
	text-align: center;
	color: white;
	padding: 1em;
}

.login {
	max-width: 100%;
}
.message p {
  margin: 0;
  display: inline;
}

.text-container {
	margin: 1.75em;
}

.description {
	color: gray;
}

.sub-title {
	text-align: center;
}

.subscriber-list-dropdown {
	width: 25em;
	max-height: 16em;
	overflow-y: auto;
	overflow-x: hidden;
}

.subscriber-list-overlay {
	max-width: 80%;
}

.app {
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
}

.app-container {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
}

.chat-header {
	width: 100%;
	height: 40pt;
}

.disabled {
	color: gray !important;
	cursor: not-allowed !important;
}

.chatlist-container {
	height: 100%;
	width: 100%;
  display: flex;
  flex-direction: column;
  overflow: hidden;
  box-shadow: 0 0 8pt 0 rgba(0, 0, 0, 0.3);
}

.chatlist-header {
  background-color: rgb(100, 180, 245);
  color: #fff;
  margin: 0;
  height: 40pt;
  font-size: 20pt;
  display: flex;
  align-items: center;
  justify-content: center;
}

.title {
  font-family: 'Pacifico', cursive;
}

.join-button {
	cursor: pointer;
}

.subscriber-list-dropdown .subscriber {
	user-select: all;
}

.new {
  margin: 10pt;
  font-size: 14pt;
  flex: 1;
  text-align: right;
}

.no-flex {
	flex: unset;
}

.popout {
	text-align: left !important;
	align-self: end;
	font-size: 14pt;
	margin: 10pt;
}

.chatlist-header .empty {
  margin: 10pt;
  flex: 1;
}

.chatlist-container .chatlist {
  flex: 1;
  box-sizing: border-box;
  padding: 0;
  margin: 0;
  overflow-y: scroll;
}

.chatlist-container .chatlist .chat {
  background: #fff;
  list-style: none;
  cursor: pointer;
  padding: 10pt 15pt;
  border-bottom: 1pt solid rgba(0, 0, 0, 0.3);
}

.chatlist-container .chatlist .chat .chat-info {
  display: flex;
  justify-content: space-between;
}

.chatlist-container .chatlist .chat .chat-info .chat-name {
  text-align: left;
  font-size: 16pt;
  word-break: break-word;
}

.chatlist-container .chatlist .chat .chat-info .chat-info-fill {
  flex: 1;
}

.chatlist-container .chatlist .chat .chat-info .chat-time {
  text-align: right;
  font-size: 14pt;
  opacity: 0.4;
}

.chatlist-container .chatlist .chat .chat-preview {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  font-size: 14pt;
  opacity: 0.4;
  margin-top: 5pt;
}

.rc-tooltip-content {
	max-width: 250px;
	word-break: break-all;
}

.chatroom {
  width: 100%;
  height: calc(100% - 40pt);
  overflow: hidden;
  box-shadow: 0 0 8pt 0 rgba(0, 0, 0, 0.3);
}

.chatroom-header {
  background-color: rgb(100, 180, 245);
  color: #fff;
  margin: 0;
  height: 40pt;
  font-size: 20pt;
  display: flex;
  align-items: center;
  justify-content: center;
  position: fixed;
  width: 100%;
}

.chatroom-header .chatname {
	overflow: hidden;
	text-overflow: ellipsis;
	flex: 1;
	text-align: center;
}

.chatroom-header .back {
  margin: 1em;
  font-size: 0.5em;
  flex: 0;
  cursor: pointer;
}

.chatroom-header .empty {
  margin: 10pt;
}

.chatroom .emojis img {
  max-height: 50pt;
  cursor: pointer;
}

.messages-container {
	/* Firefox bug with flex-direction and scrolling makes this approach less than desirable. */
	/*display: flex;*/
	/*flex-direction: column;*/
	overflow-y: scroll;
  box-sizing: border-box;
  padding: 0 20pt;
  margin: 0;
  height: 100%;
  /*scroll-behavior: smooth;*/
}
.messages {
	/*display:flex;*/
	/*flex-direction: column-reverse;*/
  flex-grow: 1;
  padding: 0;
}
ul.messages > li {
	flex: 1;
}
.messages-container-outer {
	/* Minus height of text box */
	height: calc(100% - 5em);
}

.message {
  background-color: #c0e5f7;
  padding: 0.5em 1em;
  border-radius: 2pt;
  list-style: none;
  margin: 0.5em 0;
  word-wrap: anywhere;
  white-space: pre-line;
}

.input.narrow {
	height: 2.2em;
	padding: 0.3em;
}

.narrow input {
	width: 100%;
}

.avatar {
  color: #117744;
  cursor: pointer;
}

.me {
  border-left: 3px dashed hsla(0, 88.9%, 45.9%, 0.8);
}

.refers-to-me {
	background-color: #a6d0f0;
}

.ping {
	margin: 0 0.3em;
}
.ping.nice {
	color: #4e770e;
}
.ping.ok {
	color: #a05800;
}
.ping.bad {
	color: darkred;
}

.chatroom .messages .message a {
  text-decoration: none;
  color: #3498db;
}

.input {
  height: 5em;
  width: 100%;
  background: rgb(100, 180, 245);
  display: flex;
  flex-direction: row;
  align-items: center;
}

.message blockquote {
	border-left: 0.25em solid hsl(200, 1.3%, 55.1%);
	color: hsl(0, 9.1%, 50.4%);
	padding: 0 1em;
	margin-left: 1em;
	margin-right: 0;
}

.message code {
	background-color: rgb(248, 248, 248);
}

.input textarea {
  outline: 0;
  border: 0;
  border-top-left-radius: 5pt;
  border-bottom-left-radius: 5pt;
  margin-left: 5pt;
  height: 92%;
  margin-top: 2.5px;
  width: 99%;
  box-sizing: border-box;
  font-size: 14pt;
  flex: 1;
  min-width: 10%;
  resize: none;
  overflow: hidden;
  padding: 5px;
}

.input input[type="submit"],
.input.submit {
  background: transparent;
  border: 1pt solid #fff;
  height: 95%;
  width: 70pt;
  font-size: 14pt;
  box-sizing: border-box;
  border-top-right-radius: 5pt;
  border-bottom-right-radius: 5pt;
  margin-right: 5pt;
  cursor: pointer;
  transition: all 0.3s ease;
}

.input input[type="submit"]:hover,
.input.submit:hover {
  background: #1ee494;
  color: #fff;
}

.loader-margin {
  margin-right: 1em;
}
.loader {
  position: relative;
  box-sizing: border-box;
  display: inline-block;
  height: 1em;
  width: 1em;
  animation: spinner-reveal 1.4s steps(1, end) infinite,
    spinner-rotation 1.4s ease-in-out infinite;
  clip-path: inset(0 0 0 50%);
}
.loader.big {
  height: 64pt;
  width: 64pt;
}
.loader::before,
.loader::after {
  box-sizing: border-box;
  content: "";
  width: 100%;
  height: 100%;
  border: 2pt solid #fff;
  border-radius: 50%;
  position: absolute;
  top: 0;
  left: 0;
  clip-path: inset(0 50% 0 0);
  animation: spinner-rotation-a 1.4s linear infinite;
  transition: border-color 0.5s ease-out;
}
.loader::after {
  animation-name: spinner-rotation-b;
}
/***
 * Animations
 */
@keyframes spinner-rotation {
  100% {
    transform: rotate(360deg);
  }
}
@keyframes spinner-rotation-a {
  40%,
  60% {
    transform: rotate(180deg);
  }
  100% {
    transform: rotate(540deg);
  }
}
@keyframes spinner-rotation-b {
  40% {
    transform: rotate(180deg);
  }
  80% {
    transform: rotate(360deg);
  }
  100% {
    transform: rotate(540deg);
  }
}
@keyframes spinner-reveal {
  40% {
    clip-path: inset(0 0 0 0);
  }
  80% {
    clip-path: inset(0 50% 0 0);
  }
}
